<template>
    <div class="edit-view">
        <el-form
            :model="formData"
            :rules="rules"
            ref="form"
            label-width="92px"
            label-position="right"
            size="small"
            style="max-width: 500px;"
        >
            <el-form-item prop="packageId" label="packageId">
                <el-select v-model="formData.packageId" clearable filterable placeholder="请选择">
                    <el-option
                        v-for="item in packageIdOptions"
                        :key="item.value"
                        :label="item.label"
                        :value="item.value"
                    >
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="specification" label="规格">
                <el-input v-model="formData.specification"></el-input>
            </el-form-item>
            <el-form-item prop="day" label="日期">
                <el-date-picker v-model="formData.day" type="date" value-format="yyyy-MM-dd" placeholder="选择日期时间">
                </el-date-picker>
            </el-form-item>
            <el-form-item prop="inventory" label="库存">
                <el-input-number type="number" v-model="formData.inventory"></el-input-number>
            </el-form-item>
            <el-form-item prop="price" label="价格">
                <el-input-number type="number" v-model="formData.price"></el-input-number>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving" type="danger" v-if="formData.id">删除 </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
export default {
    name: 'StockEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('stock/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
        this.$http
            .get('/package/allList', { size: 1000, query: { del: false } })
            .then(res => {
                if (res.content.length > 0) {
                    res.content.forEach(item => {
                        this.packageIdOptions.push({
                            label: item.name,
                            value: item.id
                        });
                    });
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {
                packageId: [
                    {
                        required: true,
                        message: '请输入packageId',
                        trigger: 'blur'
                    }
                ],
                price: [
                    {
                        required: true,
                        message: '请输入价格',
                        trigger: 'blur'
                    }
                ]
            },
            packageIdOptions: []
        };
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };

            this.saving = true;
            this.$http
                .post('/stock/save', data, { body: 'json' })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/stock/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
